Imports System.Net
Imports System.Net.Sockets
Imports System.Text

Public Class Client : Inherits TCPBase

    Private _TcpClient As TcpClient
    Private _Stream As NetworkStream
    Dim Buf(&H400 - 1) As Byte

    Public Sub New(ByVal TC As TcpClient)
        _TcpClient = TC
        _Stream = _TcpClient.GetStream
        _Stream.BeginRead(Buf, 0, Buf.Length, AddressOf EndRead, Nothing)
    End Sub

    Private Sub EndRead(ByVal ar As IAsyncResult)
        If MyBase.IsDisposed Then Return
        Dim read As Integer = _Stream.EndRead(ar)
        If read = 0 Then 'leere Datenbermittlung signalisiert Verbindungsabbruch
            CrossThread.RunGui(AddressOf OnStatusMessage, _
                               New MessageEventargs("CounterClient shut down"))
            CrossThread.RunGui(AddressOf MyBase.Dispose)
            Return
        End If
        Dim SB As New StringBuilder(Encoding.UTF8.GetString(Buf, 0, read))
        Do While _Stream.DataAvailable
            read = _Stream.Read(Buf, 0, Buf.Length)
            SB.Append(Encoding.UTF8.GetString(Buf, 0, read))
        Loop
        CrossThread.RunGui(AddressOf OnChatMessage, _
                           New MessageEventargs(SB.ToString))
        _Stream.BeginRead(Buf, 0, Buf.Length, AddressOf EndRead, Nothing)
    End Sub

    Public Overrides Sub Send(ByVal Msg As String)
        Dim Buf() As Byte = Encoding.UTF8.GetBytes(Msg)
        _Stream.Write(Buf, 0, Buf.Length)
    End Sub

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        DisposeAll(_Stream, _TcpClient)
    End Sub

End Class
